require_relative '../spec_helper.rb'
require 'vcoworkflows'
require 'erb'

include ERB::Util

# rubocop:disable LineLength
# rubocop:disable Metrics/BlockLength

describe VcoWorkflows::WorkflowService, 'WorkflowService' do
  before(:each) do
    # Set up some basic starting data
    @workflow_name = 'Request Component'
    @workflow_id = '6e04a460-4a45-4e16-9603-db2922c24462'
    @execution_id = 'ff8080814a1cb55c014a6481a9927a78'
    @workflow_json = '{"output-parameters":[{"name":"result","type":"string","description":"Catalog item request state"},{"name":"requestNumber","type":"number"},{"name":"requestCompletionDetails","type":"string"}],"relations":{"link":[{"rel":"up","href":"https://vco.example.com:8281/vco/api/inventory/System/Workflows/dlinsley%2540vmware.com/vCAC/"},{"rel":"executions","href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/"},{"rel":"presentation","href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/presentation/"},{"rel":"tasks","href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/tasks/"},{"rel":"icon","href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/icon/"},{"rel":"schema","href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/schema/"},{"rel":"permissions","href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/permissions/"},{"rel":"interactions","href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/interactions/"}]},"id":"6e04a460-4a45-4e16-9603-db2922c24462","name":"Request Component","version":"0.0.33","description":"","href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/","customized-icon":false,"input-parameters":[{"name":"coreCount","type":"string"},{"name":"ramMB","type":"string"},{"name":"onBehalfOf","type":"string"},{"name":"machineCount","type":"string"},{"name":"businessUnit","type":"string"},{"name":"reservation","type":"string"},{"name":"location","type":"string"},{"name":"environment","type":"string"},{"name":"image","type":"string","description":"vCenter template name"},{"name":"runlist","type":"Array/string","description":"Chef Runlist for first run.  Leave empty for no Chef"},{"name":"nodename","type":"string","description":"Chef Nodename"},{"name":"component","type":"string"},{"name":"attributesJS","type":"string","description":"JSON object of vCenter Attributes to apply to VM(s)"}]}'
    @token_json = '{"relations":{"link":[{"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/","rel":"up"},{"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a6481a9927a78/","rel":"remove"},{"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a6481a9927a78/logs/","rel":"logs"},{"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a6481a9927a78/state/","rel":"state"}]},"id":"ff8080814a1cb55c014a6481a9927a78","state":"completed","name":"Request Component","href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a6481a9927a78/","start-date":1419025426833,"end-date":1419026124320,"started-by":"someuser@EXAMPLE.COM","input-parameters":[{"value":{"string":{"value":"2"}},"type":"string","name":"coreCount","scope":"local"},{"value":{"string":{"value":"2048"}},"type":"string","name":"ramMB","scope":"local"},{"value":{"string":{"value":"svcacct@example.com"}},"type":"string","name":"onBehalfOf","scope":"local"},{"value":{"string":{"value":"1"}},"type":"string","name":"machineCount","scope":"local"},{"value":{"string":{"value":"aw"}},"type":"string","name":"businessUnit","scope":"local"},{"value":{"string":{"value":"nonprodlinux"}},"type":"string","name":"reservation","scope":"local"},{"value":{"string":{"value":"us_east"}},"type":"string","name":"location","scope":"local"},{"value":{"string":{"value":"dev1"}},"type":"string","name":"environment","scope":"local"},{"value":{"string":{"value":"centos-6.6-x86_64-20141203-1"}},"type":"string","name":"image","scope":"local"},{"value":{"array":{"elements":[{"string":{"value":"role[loc_uswest]"}},{"string":{"value":"role[base]"}},{"string":{"value":"role[api]"}}]}},"type":"Array/string","name":"runlist","scope":"local"},{"value":{"string":{"value":""}},"type":"string","name":"nodename","scope":"local"},{"value":{"string":{"value":"api"}},"type":"string","name":"component","scope":"local"},{"value":{"string":{"value":""}},"type":"string","name":"attributesJS","scope":"local"}],"output-parameters":[{"value":{"string":{"value":"SUCCESSFUL"}},"type":"string","name":"result","scope":"local"},{"value":{"number":{"value":326.0}},"type":"number","name":"requestNumber","scope":"local"},{"value":{"string":{"value":"Request succeeded. Created vm00378."}},"type":"string","name":"requestCompletionDetails","scope":"local"}]}'
    @presentation_json = '{"output-parameters":[{"name":"machineCount","type":"string"},{"name":"location","type":"string"},{"name":"image","type":"string","description":"vCenter template name"},{"name":"coreCount","type":"string"},{"name":"ramMB","type":"string"},{"name":"onBehalfOf","type":"string"},{"name":"businessUnit","type":"string"},{"name":"environment","type":"string"},{"name":"component","type":"string"},{"name":"reservation","type":"string"},{"name":"runlist","type":"Array/string","description":"Chef Runlist for first run.  Leave empty for no Chef"},{"name":"nodename","type":"string","description":"Chef Nodename"},{"name":"attributesJS","type":"string","description":"JSON object of vCenter Attributes to apply to VM(s)"}],"input-parameters":[{"name":"businessUnit","type":"string","description":"businessUnit"},{"name":"environment","type":"string","description":"environment"},{"name":"component","type":"string","description":"component"},{"name":"onBehalfOf","type":"string","description":"On Behalf of User: (user@domain format)"},{"name":"machineCount","type":"string","description":"machineCount"},{"name":"image","type":"string","description":"image"},{"name":"coreCount","type":"string","description":"coreCount"},{"name":"ramMB","type":"string","description":"ramSizeMB"},{"name":"runlist","type":"Array/string","description":"runlist"},{"name":"reservation","type":"string","description":"reservation"},{"name":"location","type":"string","description":"location"},{"name":"attributesJS","type":"string","description":"JSON object of vCenter Attributes to apply to VM(s)"},{"name":"nodename","type":"string","description":"Chef Nodename"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/presentation/","name":"Request Component","id":"6e04a460-4a45-4e16-9603-db2922c24462","steps":[{"step":{"messages":[],"hidden":false,"elements":[{"fields":[{"display-name":"businessUnit","constraints":[{"@type":"mandatory"}],"@type":"field","fields":[],"id":"businessUnit","description":"businessUnit","hidden":false,"messages":[],"decorators":[{"array":{"elements":[{"string":{"value":"an"}},{"string":{"value":"aw"}},{"string":{"value":"soi"}}]},"@type":"drop-down"}],"type":"string"},{"display-name":"environment","constraints":[{"@type":"mandatory"}],"@type":"field","fields":[],"id":"environment","description":"environment","hidden":false,"messages":[],"decorators":[],"type":"string"},{"display-name":"component","constraints":[{"@type":"mandatory"}],"@type":"field","fields":[],"id":"component","description":"component","hidden":false,"messages":[],"decorators":[],"type":"string"},{"display-name":"On Behalf of User: (user@domain format)","constraints":[],"@type":"field","fields":[],"id":"onBehalfOf","description":"On Behalf of User: (user@domain format)","hidden":false,"messages":[],"decorators":[],"type":"string"},{"display-name":"machineCount","constraints":[],"@type":"field","fields":[],"id":"machineCount","description":"machineCount","hidden":false,"messages":[],"decorators":[{"array":{"elements":[{"string":{"value":"1"}},{"string":{"value":"2"}},{"string":{"value":"3"}},{"string":{"value":"4"}},{"string":{"value":"5"}},{"string":{"value":"6"}},{"string":{"value":"7"}},{"string":{"value":"8"}},{"string":{"value":"9"}},{"string":{"value":"10"}}]},"@type":"drop-down"}],"type":"string"},{"display-name":"image","constraints":[{"@type":"mandatory"}],"@type":"field","fields":[],"id":"image","description":"image","hidden":false,"messages":[],"decorators":[{"array":{"elements":[{"string":{"value":"vcaccentos65v8-agent"}},{"string":{"value":"win2012std"}},{"string":{"value":"vcac2012std"}},{"string":{"value":"centos-6.6-x86_64-20141203-1"}},{"string":{"value":"v8-centos65-agent"}},{"string":{"value":"vcac2008r2std"}},{"string":{"value":"oracle-6.5-x86_64-20141203-1"}},{"string":{"value":"centos65v8"}},{"string":{"value":"w2012r2std_coreservices"}},{"string":{"value":"2008r2std"}}]},"@type":"drop-down"}],"type":"string"},{"display-name":"coreCount","constraints":[{"@type":"mandatory"}],"@type":"field","fields":[],"id":"coreCount","description":"coreCount","hidden":false,"messages":[],"decorators":[{"@type":"refresh-on-change"},{"array":{"elements":[{"string":{"value":"1"}},{"string":{"value":"2"}},{"string":{"value":"4"}},{"string":{"value":"8"}}]},"@type":"drop-down"}],"type":"string"},{"display-name":"ramSizeMB","constraints":[{"@type":"mandatory"}],"@type":"field","fields":[],"id":"ramMB","description":"ramSizeMB","hidden":false,"messages":[],"decorators":[{"array":{"elements":[null]},"@type":"drop-down"}],"type":"string"},{"display-name":"runlist","constraints":[],"@type":"field","fields":[],"id":"runlist","description":"runlist","hidden":false,"messages":[],"decorators":[],"type":"Array/string"},{"display-name":"reservation","constraints":[{"@type":"mandatory"}],"@type":"field","fields":[],"id":"reservation","description":"reservation","hidden":false,"messages":[],"decorators":[],"type":"string"},{"display-name":"location","constraints":[],"@type":"field","fields":[],"id":"location","description":"location","hidden":false,"messages":[],"decorators":[],"type":"string"},{"display-name":"JSON object of vCenter Attributes to apply to VM(s)","constraints":[],"@type":"field","fields":[],"id":"attributesJS","description":"JSON object of vCenter Attributes to apply to VM(s)","hidden":false,"messages":[],"decorators":[{"@type":"multiline"}],"type":"string"},{"display-name":"Chef Nodename","constraints":[],"@type":"field","fields":[],"id":"nodename","description":"Chef Nodename","hidden":false,"messages":[],"decorators":[],"type":"string"}],"messages":[],"hidden":false,"@type":"group"}]}}],"relations":{"link":[{"rel":"up","href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/"},{"rel":"instances","href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/presentation/instances/"},{"rel":"add","href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/presentation/instances/"}]}}'
    @log_json = '{"logs":[{"entry":{"severity":"info","time-stamp":1419026124333,"user":"someuser","short-description":"Workflow \'Request Component\' has completed","long-description":"Workflow \'Request Component\' has completed"}},{"entry":{"severity":"info","time-stamp":1419026123927,"user":"someuser","short-description":"Workflow \'Request Component\' has resumed","long-description":"Workflow \'Request Component\' has resumed"}},{"entry":{"severity":"info","time-stamp":1419025439183,"user":"someuser","short-description":"Workflow is paused","long-description":"Workflow \'Request Component\' has paused while waiting on signal"}},{"entry":{"severity":"info","time-stamp":1419025426870,"user":"someuser","short-description":"Workflow \'Request Component\' has started","long-description":"Workflow \'Request Component\' has started"}}]}'
    @input_param_count = 13
    @output_param_count = 3
    @required_param_count = 7
    @url = 'https://vco.example.com:8281/vco/api'
    @username = 'jdoe'
    @password = 's3cr3t'

    # Mock VcoSession
    @session = double('session')
  end

  it 'should initialize correctly' do
    service = VcoWorkflows::WorkflowService.new(@session)
    expect(service).to_not eq(nil)
    expect(service.class).to eq(VcoWorkflows::WorkflowService)
  end

  it 'should get workflow by id' do
    response = double('response')
    allow(response).to receive(:body) { @workflow_json }
    allow(@session).to receive(:get) { response }
    expect(@session).to receive(:get).with("/workflows/#{@workflow_id}")
    service = VcoWorkflows::WorkflowService.new(@session)
    res = service.get_workflow_for_id(@workflow_id)
    expect(res).to_not eq(nil)
    expect(res.class).to eq(String)
    expect(res).to eql(@workflow_json)
  end

  it 'should get workflow by name' do
    query_json = '{"link":[{"attributes":[{"value":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/","name":"itemHref"},{"value":"6e04a460-4a45-4e16-9603-db2922c24462","name":"id"},{"value":"vCAC","name":"categoryName"},{"value":"true","name":"canExecute"},{"value":"https://vco.example.com:8281/vco/api/catalog/System/WorkflowCategory/ff80808148eb04940149d404c1506b3b/","name":"categoryHref"},{"value":"","name":"description"},{"value":"Request Component","name":"name"},{"value":"false","name":"customIcon"},{"value":"Workflow","name":"type"},{"value":"true","name":"canEdit"},{"value":"0.0.33","name":"version"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/","rel":"down"}],"total":1}'
    response = double('response')
    allow(response).to receive(:body) { query_json }
    allow(@session).to receive(:get) { response }
    expect(@session).to receive(:get).with("/workflows?conditions=name=#{url_encode(@workflow_name)}")
    service = VcoWorkflows::WorkflowService.new(@session)
    allow(service).to receive(:get_workflow_for_id) { @workflow_json }
    expect(service).to receive(:get_workflow_for_id).with(@workflow_id)
    wf_json = service.get_workflow_for_name(@workflow_name)
    expect(wf_json).to_not eq(nil)
    expect(wf_json.class).to eq(String)
    expect(wf_json).to eql(@workflow_json)
  end

  it 'should provide a list of executions' do
    executions_json = '{"relations":{"total":100,"link":[{"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/","rel":"up"},{"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/","rel":"add"},{"attributes":[{"value":"ff8080814a1cb55c014a354875ad15be","name":"id"},{"value":"2014-12-10T17:39:08.843Z","name":"startDate"},{"value":"2014-12-10T17:39:13.827Z","name":"endDate"},{"value":"svcacct@example.","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"value":"Compute Inputs","name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a354875ad15be/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a354c6088163a","name":"id"},{"value":"2014-12-10T17:43:25.577Z","name":"startDate"},{"value":"2014-12-10T18:17:00.107Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a354c6088163a/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a354eaa6d1666","name":"id"},{"value":"2014-12-10T17:45:55.567Z","name":"startDate"},{"value":"2014-12-10T17:48:24.880Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"value":"Wait for catalog item request","name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a354eaa6d1666/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a355989dc1701","name":"id"},{"value":"2014-12-10T17:57:48.123Z","name":"startDate"},{"value":"2014-12-10T18:03:28.990Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"value":"Wait for catalog item request","name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a355989dc1701/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a35655e0d177f","name":"id"},{"value":"2014-12-10T18:10:43.340Z","name":"startDate"},{"value":"2014-12-10T18:15:56.477Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a35655e0d177f/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a35c384ec184e","name":"id"},{"value":"2014-12-10T19:53:33.677Z","name":"startDate"},{"value":"2014-12-10T20:27:10.093Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a35c384ec184e/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a35cee07e18c9","name":"id"},{"value":"2014-12-10T20:05:58.013Z","name":"startDate"},{"value":"2014-12-10T20:39:30.107Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a35cee07e18c9/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a35e4e2ae199c","name":"id"},{"value":"2014-12-10T20:30:00.367Z","name":"startDate"},{"value":"2014-12-10T20:36:28.633Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a35e4e2ae199c/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a35e9689f1a2b","name":"id"},{"value":"2014-12-10T20:34:56.797Z","name":"startDate"},{"value":"2014-12-10T20:41:03.760Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a35e9689f1a2b/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a35edc0a91adb","name":"id"},{"value":"2014-12-10T20:39:41.480Z","name":"startDate"},{"value":"2014-12-10T20:45:21.347Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a35edc0a91adb/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a35ef096a1b40","name":"id"},{"value":"2014-12-10T20:41:05.640Z","name":"startDate"},{"value":"2014-12-10T20:47:21.173Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a35ef096a1b40/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a35f81b151c8c","name":"id"},{"value":"2014-12-10T20:50:59.987Z","name":"startDate"},{"value":"2014-12-10T20:56:30.040Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a35f81b151c8c/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a35fc933d1d0a","name":"id"},{"value":"2014-12-10T20:55:52.893Z","name":"startDate"},{"value":"2014-12-10T21:02:27.343Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a35fc933d1d0a/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a3600e5911d77","name":"id"},{"value":"2014-12-10T21:00:36.113Z","name":"startDate"},{"value":"2014-12-10T21:07:02.500Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a3600e5911d77/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a361e2bed1ed1","name":"id"},{"value":"2014-12-10T21:32:34.670Z","name":"startDate"},{"value":"2014-12-10T21:37:36.703Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a361e2bed1ed1/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a362989f51f54","name":"id"},{"value":"2014-12-10T21:44:59.637Z","name":"startDate"},{"value":"2014-12-10T21:50:28.687Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a362989f51f54/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a364a070f1ff7","name":"id"},{"value":"2014-12-10T22:20:28.817Z","name":"startDate"},{"value":"2014-12-10T22:25:48.610Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a364a070f1ff7/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a36a5bd2d2214","name":"id"},{"value":"2014-12-11T00:00:39.213Z","name":"startDate"},{"value":"2014-12-11T00:06:30.540Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a36a5bd2d2214/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a3a627f4b2496","name":"id"},{"value":"2014-12-11T17:25:41.323Z","name":"startDate"},{"value":"2014-12-11T17:31:41.463Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a3a627f4b2496/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a3a6783ea2529","name":"id"},{"value":"2014-12-11T17:31:10.187Z","name":"startDate"},{"value":"2014-12-11T17:36:52.760Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a3a6783ea2529/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a3a6b767c2572","name":"id"},{"value":"2014-12-11T17:35:28.893Z","name":"startDate"},{"value":"2014-12-11T17:45:59.917Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a3a6b767c2572/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a4eadde7d3499","name":"id"},{"value":"2014-12-15T16:00:25.213Z","name":"startDate"},{"value":"2014-12-15T16:06:56.183Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a4eadde7d3499/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a4eb73a1235b0","name":"id"},{"value":"2014-12-15T16:10:38.483Z","name":"startDate"},{"value":"2014-12-15T16:16:13.250Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a4eb73a1235b0/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a4f0c01ab3704","name":"id"},{"value":"2014-12-15T17:43:14.603Z","name":"startDate"},{"value":"2014-12-15T17:49:51.737Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"value":"Wait for catalog item request","name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a4f0c01ab3704/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a4f183b0a37c2","name":"id"},{"value":"2014-12-15T17:56:35.723Z","name":"startDate"},{"value":"2014-12-15T18:03:46.747Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"value":"Wait for catalog item request","name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a4f183b0a37c2/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a4f1aaf4137eb","name":"id"},{"value":"2014-12-15T17:59:16.547Z","name":"startDate"},{"value":"2014-12-15T18:06:22.360Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"value":"Wait for catalog item request","name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a4f1aaf4137eb/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a4f21cdf6396f","name":"id"},{"value":"2014-12-15T18:07:03.157Z","name":"startDate"},{"value":"2014-12-15T18:13:42.400Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"value":"Wait for catalog item request","name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a4f21cdf6396f/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a4f2e587d3a4c","name":"id"},{"value":"2014-12-15T18:20:45.053Z","name":"startDate"},{"value":"2014-12-15T18:26:34.740Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a4f2e587d3a4c/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a4f4d9ebc3af4","name":"id"},{"value":"2014-12-15T18:54:54.653Z","name":"startDate"},{"value":"2014-12-15T19:00:13.737Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a4f4d9ebc3af4/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a4fab3b6a3bbb","name":"id"},{"value":"2014-12-15T20:37:09.610Z","name":"startDate"},{"value":"2014-12-15T20:37:51.910Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"value":"Wait for catalog item request","name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a4fab3b6a3bbb/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a4fb467393bc6","name":"id"},{"value":"2014-12-15T20:47:10.650Z","name":"startDate"},{"value":"2014-12-15T20:47:41.030Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"value":"Wait for catalog item request","name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a4fb467393bc6/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a4ffee4fd3cd6","name":"id"},{"value":"2014-12-15T22:08:32.507Z","name":"startDate"},{"value":"2014-12-15T22:42:20.250Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"value":"Get Details","name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a4ffee4fd3cd6/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5001a1853cff","name":"id"},{"value":"2014-12-15T22:11:31.847Z","name":"startDate"},{"value":"2014-12-15T22:11:54.823Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5001a1853cff/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5004a4693d68","name":"id"},{"value":"2014-12-15T22:14:49.193Z","name":"startDate"},{"value":"2014-12-15T22:15:16.123Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5004a4693d68/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5005c15f3d71","name":"id"},{"value":"2014-12-15T22:16:02.143Z","name":"startDate"},{"value":"2014-12-15T22:16:35.040Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5005c15f3d71/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a500710713d7a","name":"id"},{"value":"2014-12-15T22:17:27.920Z","name":"startDate"},{"value":"2014-12-15T22:20:13.257Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a500710713d7a/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a500980a03dc8","name":"id"},{"value":"2014-12-15T22:20:07.710Z","name":"startDate"},{"value":"2014-12-15T22:20:44.457Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a500980a03dc8/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a500bf6bf3dd6","name":"id"},{"value":"2014-12-15T22:22:49.023Z","name":"startDate"},{"value":"2014-12-15T22:23:20.083Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a500bf6bf3dd6/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a500ebdcf3de3","name":"id"},{"value":"2014-12-15T22:25:51.057Z","name":"startDate"},{"value":"2014-12-15T22:28:31.970Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a500ebdcf3de3/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5011dec23e33","name":"id"},{"value":"2014-12-15T22:29:16.097Z","name":"startDate"},{"value":"2014-12-15T22:29:39.100Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5011dec23e33/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a501877a33e46","name":"id"},{"value":"2014-12-15T22:36:28.450Z","name":"startDate"},{"value":"2014-12-15T22:38:44.137Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a501877a33e46/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5019ec473e81","name":"id"},{"value":"2014-12-15T22:38:03.847Z","name":"startDate"},{"value":"2014-12-15T22:40:28.393Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5019ec473e81/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a502611c33ee2","name":"id"},{"value":"2014-12-15T22:51:19.877Z","name":"startDate"},{"value":"2014-12-15T22:57:54.097Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a502611c33ee2/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5026643b3eeb","name":"id"},{"value":"2014-12-15T22:51:40.987Z","name":"startDate"},{"value":"2014-12-15T22:52:25.070Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5026643b3eeb/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a502c380b4171","name":"id"},{"value":"2014-12-15T22:58:02.890Z","name":"startDate"},{"value":"2014-12-15T23:07:15.767Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a502c380b4171/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5036ad9244da","name":"id"},{"value":"2014-12-15T23:09:28.337Z","name":"startDate"},{"value":"2014-12-15T23:16:16.843Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5036ad9244da/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a504a66ca4620","name":"id"},{"value":"2014-12-15T23:31:00.937Z","name":"startDate"},{"value":"2014-12-15T23:36:27.130Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a504a66ca4620/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a54697aa44bbd","name":"id"},{"value":"2014-12-16T18:43:26.500Z","name":"startDate"},{"value":"2014-12-16T18:51:00.870Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a54697aa44bbd/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a54750ad34c89","name":"id"},{"value":"2014-12-16T18:56:04.307Z","name":"startDate"},{"value":"2014-12-16T19:02:41.587Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a54750ad34c89/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a548abf564d51","name":"id"},{"value":"2014-12-16T19:19:46.773Z","name":"startDate"},{"value":"2014-12-16T19:25:26.757Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a548abf564d51/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5493748d4db9","name":"id"},{"value":"2014-12-16T19:29:17.453Z","name":"startDate"},{"value":"2014-12-16T19:35:48.240Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5493748d4db9/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a549afed94edf","name":"id"},{"value":"2014-12-16T19:37:31.610Z","name":"startDate"},{"value":"2014-12-16T19:43:36.443Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a549afed94edf/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a54bad99d4fa0","name":"id"},{"value":"2014-12-16T20:12:19.230Z","name":"startDate"},{"value":"2014-12-16T20:17:48.910Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a54bad99d4fa0/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a54d130ec523f","name":"id"},{"value":"2014-12-16T20:36:43.370Z","name":"startDate"},{"value":"2014-12-16T20:43:36.920Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a54d130ec523f/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a54de927c5557","name":"id"},{"value":"2014-12-16T20:51:20.317Z","name":"startDate"},{"value":"2014-12-16T21:01:14.217Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a54de927c5557/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a54ee69d55ab1","name":"id"},{"value":"2014-12-16T21:08:38.487Z","name":"startDate"},{"value":"2014-12-16T21:19:55.677Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a54ee69d55ab1/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a54f633fb60ce","name":"id"},{"value":"2014-12-16T21:17:08.987Z","name":"startDate"},{"value":"2014-12-16T21:28:49.913Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a54f633fb60ce/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a54f7067661f9","name":"id"},{"value":"2014-12-16T21:18:02.870Z","name":"startDate"},{"value":"2014-12-16T21:30:23.283Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a54f7067661f9/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a552ac01779c9","name":"id"},{"value":"2014-12-16T22:14:32.727Z","name":"startDate"},{"value":"2014-12-16T22:25:12.700Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a552ac01779c9/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a555261557ba2","name":"id"},{"value":"2014-12-16T22:57:49.910Z","name":"startDate"},{"value":"2014-12-16T23:09:42.100Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a555261557ba2/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5568870e00ea","name":"id"},{"value":"2014-12-16T23:22:01.357Z","name":"startDate"},{"value":"2014-12-16T23:29:52.857Z","name":"endDate"},{"value":"svcacct@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5568870e00ea/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a565db80904b6","name":"id"},{"value":"2014-12-17T03:49:50.217Z","name":"startDate"},{"value":"2014-12-17T04:00:43.247Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a565db80904b6/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a595e2cef090d","name":"id"},{"value":"2014-12-17T17:49:11.790Z","name":"startDate"},{"value":"2014-12-17T18:00:48.813Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a595e2cef090d/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a596bb8420b53","name":"id"},{"value":"2014-12-17T18:03:59.427Z","name":"startDate"},{"value":"2014-12-17T18:14:53.647Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a596bb8420b53/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a598611af0d4c","name":"id"},{"value":"2014-12-17T18:32:46.257Z","name":"startDate"},{"value":"2014-12-17T18:43:47.177Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a598611af0d4c/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5a079a6c132d","name":"id"},{"value":"2014-12-17T20:54:15.403Z","name":"startDate"},{"value":"2014-12-17T20:57:37.420Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5a079a6c132d/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5a36fafc13fd","name":"id"},{"value":"2014-12-17T21:46:00.317Z","name":"startDate"},{"value":"2014-12-17T21:57:45.140Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5a36fafc13fd/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5a3713541403","name":"id"},{"value":"2014-12-17T21:46:06.547Z","name":"startDate"},{"value":"2014-12-17T21:58:16.453Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5a3713541403/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5a3803ee1437","name":"id"},{"value":"2014-12-17T21:47:08.143Z","name":"startDate"},{"value":"2014-12-17T21:53:01.083Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5a3803ee1437/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5a381a5b144c","name":"id"},{"value":"2014-12-17T21:47:13.883Z","name":"startDate"},{"value":"2014-12-17T21:58:47.757Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5a381a5b144c/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5a3a882214e6","name":"id"},{"value":"2014-12-17T21:49:53.057Z","name":"startDate"},{"value":"2014-12-17T21:56:10.847Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5a3a882214e6/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5a3ac3621520","name":"id"},{"value":"2014-12-17T21:50:08.227Z","name":"startDate"},{"value":"2014-12-17T22:01:01.883Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5a3ac3621520/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5a48bbc11d1e","name":"id"},{"value":"2014-12-17T22:05:23.777Z","name":"startDate"},{"value":"2014-12-17T22:11:52.040Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5a48bbc11d1e/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5a48e1d91d24","name":"id"},{"value":"2014-12-17T22:05:33.530Z","name":"startDate"},{"value":"2014-12-17T22:17:29.443Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5a48e1d91d24/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5abd11212073","name":"id"},{"value":"2014-12-18T00:12:27.810Z","name":"startDate"},{"value":"2014-12-18T00:24:49.590Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5abd11212073/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5abd9958207a","name":"id"},{"value":"2014-12-18T00:13:02.680Z","name":"startDate"},{"value":"2014-12-18T00:25:21.307Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5abd9958207a/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5abe42b420a0","name":"id"},{"value":"2014-12-18T00:13:46.037Z","name":"startDate"},{"value":"2014-12-18T00:25:52.400Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5abe42b420a0/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5abed7ea20cc","name":"id"},{"value":"2014-12-18T00:14:24.233Z","name":"startDate"},{"value":"2014-12-18T00:25:52.143Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5abed7ea20cc/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5abf213d20ed","name":"id"},{"value":"2014-12-18T00:14:43.007Z","name":"startDate"},{"value":"2014-12-18T00:28:27.727Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5abf213d20ed/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5b3b39aa300a","name":"id"},{"value":"2014-12-18T02:30:15.723Z","name":"startDate"},{"value":"2014-12-18T02:42:37.863Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5b3b39aa300a/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5b3b58943010","name":"id"},{"value":"2014-12-18T02:30:23.637Z","name":"startDate"},{"value":"2014-12-18T02:42:05.883Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5b3b58943010/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5b3b75693017","name":"id"},{"value":"2014-12-18T02:30:31.017Z","name":"startDate"},{"value":"2014-12-18T02:43:33.527Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5b3b75693017/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5b3b8f6b301d","name":"id"},{"value":"2014-12-18T02:30:37.677Z","name":"startDate"},{"value":"2014-12-18T02:43:33.837Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5b3b8f6b301d/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5b3baa0e3024","name":"id"},{"value":"2014-12-18T02:30:44.493Z","name":"startDate"},{"value":"2014-12-18T02:44:48.687Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5b3baa0e3024/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5f279a764460","name":"id"},{"value":"2014-12-18T20:47:18.647Z","name":"startDate"},{"value":"2014-12-18T20:53:15.683Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5f279a764460/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5f2cdb844510","name":"id"},{"value":"2014-12-18T20:53:02.980Z","name":"startDate"},{"value":"2014-12-18T21:01:06.437Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5f2cdb844510/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5fc13c3f4b0a","name":"id"},{"value":"2014-12-18T23:35:07.070Z","name":"startDate"},{"value":"2014-12-18T23:47:45.160Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5fc13c3f4b0a/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5fc1812b4b11","name":"id"},{"value":"2014-12-18T23:35:24.717Z","name":"startDate"},{"value":"2014-12-18T23:46:45.230Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5fc1812b4b11/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5fc199af4b17","name":"id"},{"value":"2014-12-18T23:35:30.990Z","name":"startDate"},{"value":"2014-12-18T23:48:16.600Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5fc199af4b17/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5fc1b3254b1e","name":"id"},{"value":"2014-12-18T23:35:37.510Z","name":"startDate"},{"value":"2014-12-18T23:47:45.570Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5fc1b3254b1e/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a5fc1e4834b25","name":"id"},{"value":"2014-12-18T23:35:50.147Z","name":"startDate"},{"value":"2014-12-18T23:49:50.090Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a5fc1e4834b25/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a612ba0485b40","name":"id"},{"value":"2014-12-19T06:10:56.713Z","name":"startDate"},{"value":"2014-12-19T06:12:10.410Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"failed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a612ba0485b40/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a630649ba639a","name":"id"},{"value":"2014-12-19T14:49:24.153Z","name":"startDate"},{"value":"2014-12-19T14:55:37.583Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a630649ba639a/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a63a5691d6bf2","name":"id"},{"value":"2014-12-19T17:43:12.413Z","name":"startDate"},{"value":"2014-12-19T17:49:17.013Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a63a5691d6bf2/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a63a5b5bf6bf9","name":"id"},{"value":"2014-12-19T17:43:32.030Z","name":"startDate"},{"value":"2014-12-19T17:52:00.343Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a63a5b5bf6bf9/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a6445b85b7714","name":"id"},{"value":"2014-12-19T20:38:18.457Z","name":"startDate"},{"value":"2014-12-19T20:43:57.713Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a6445b85b7714/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a644f925577cf","name":"id"},{"value":"2014-12-19T20:49:04.087Z","name":"startDate"},{"value":"2014-12-19T20:55:20.557Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a644f925577cf/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a6459f87278c0","name":"id"},{"value":"2014-12-19T21:00:25.587Z","name":"startDate"},{"value":"2014-12-19T21:06:19.517Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a6459f87278c0/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a64708829797f","name":"id"},{"value":"2014-12-19T21:25:04.170Z","name":"startDate"},{"value":"2014-12-19T21:31:03.810Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a64708829797f/","rel":"down"},{"attributes":[{"value":"ff8080814a1cb55c014a6481a9927a78","name":"id"},{"value":"2014-12-19T21:43:46.833Z","name":"startDate"},{"value":"2014-12-19T21:55:24.320Z","name":"endDate"},{"value":"someuser@example.com","name":"startedBy"},{"value":"completed","name":"state"},{"value":"Request Component","name":"name"},{"name":"currentItemDisplayName"}],"href":"https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a6481a9927a78/","rel":"down"}]}}'
    response = double('response')
    allow(response).to receive(:body) { executions_json }
    allow(@session).to receive(:get) { response }
    expect(@session).to receive(:get).with("/workflows/#{@workflow_id}/executions/")
    service = VcoWorkflows::WorkflowService.new(@session)
    executions = service.get_execution_list(@workflow_id)
    expect(executions.class).to eq(Hash)
    expect(executions.size).to eq(100)
  end

  it 'should get an execution' do
    response = double('response')
    allow(response).to receive(:body) { @token_json }
    allow(@session).to receive(:get) { response }
    expect(@session).to receive(:get).with("/workflows/#{@workflow_id}/executions/#{@execution_id}")
    service = VcoWorkflows::WorkflowService.new(@session)
    execution = service.get_execution(@workflow_id, @execution_id)
    expect(execution.class).to eq(String)
    expect(execution).to eql(@token_json)
  end

  it 'should get a log' do
    response = double('response')
    allow(response).to receive(:body) { @log_json }
    allow(@session).to receive(:get) { response }
    expect(@session).to receive(:get).with("/workflows/#{@workflow_id}/executions/#{@execution_id}/logs/")
    service = VcoWorkflows::WorkflowService.new(@session)
    log = service.get_log(@workflow_id, @execution_id)
    expect(log).to_not eq(nil)
    expect(log.class).to eq(String)
  end

  it 'should execute a workflow' do
    res_headers = {
      location: 'https://vco.example.com:8281/vco/api/workflows/6e04a460-4a45-4e16-9603-db2922c24462/executions/ff8080814a1cb55c014a6481a9927a78/'
    }
    parameter_json = '{"parameters":[{"type":"string","name":"coreCount","scope":"local","value":{"string":{"value":"2"}}},{"type":"string","name":"ramMB","scope":"local","value":{"string":{"value":"2048"}}},{"type":"string","name":"onBehalfOf","scope":"local","value":{"string":{"value":"svc.soi_vmware@dev.activenetwork.com"}}},{"type":"string","name":"machineCount","scope":"local","value":{"string":{"value":"1"}}},{"type":"string","name":"businessUnit","scope":"local","value":{"string":{"value":"aw"}}},{"type":"string","name":"reservation","scope":"local","value":{"string":{"value":"nonprodlinux"}}},{"type":"string","name":"location","scope":"local","value":{"string":{"value":"us_east"}}},{"type":"string","name":"environment","scope":"local","value":{"string":{"value":"dev1"}}},{"type":"string","name":"image","scope":"local","value":{"string":{"value":"centos-6.6-x86_64-20141203-1"}}},{"type":"Array","name":"runlist","scope":"local","value":{"array":{"elements":[{"string":{"value":"role[loc_uswest]"}},{"string":{"value":"role[base]"}},{"string":{"value":"role[aw-api]"}}]}}},{"type":"string","name":"component","scope":"local","value":{"string":{"value":"api"}}}]}'
    response = double('response')
    allow(response).to receive(:headers) { res_headers }
    allow(@session).to receive(:post) { response }
    expect(@session).to receive(:post).with("/workflows/#{@workflow_id}/executions/", parameter_json)
    service = VcoWorkflows::WorkflowService.new(@session)
    exec_id = service.execute_workflow(@workflow_id, parameter_json)
    expect(exec_id).to_not eq(nil)
    expect(exec_id.class).to eq(String)
    expect(exec_id).to eql(@execution_id)
  end
end
# rubocop:enable LineLength
